package net.sf.tomp.xml.type;

import java.util.*;

/**
 * DOCUMENT ME!
 * 
 * @author $author$
 * @version $Revision$
 */
public class TransformationsFromType {
    /** DOCUMENT ME! */
    protected Type typ;

    /** DOCUMENT ME! */
    protected Map transformations;

    /**
     * Creates a new TransformationsFromType object.
     * 
     * @param t DOCUMENT ME!
     */
    public TransformationsFromType(Type t) {
        typ = t;
        transformations = new HashMap();
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public Iterator typesIterator() {
        return transformations.keySet().iterator();
    }

    /**
     * DOCUMENT ME!
     * 
     * @param t DOCUMENT ME!
     * @param v DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    public TypeTransformation getTransformationTo(Type t, Variant v) {
        Map tts = (Map) transformations.get(t);

        if (tts == null) {
            return null;
        }

        TypeTransformation tt = (TypeTransformation) tts.get(v);

        return tt;
    }

    /**
     * DOCUMENT ME!
     * 
     * @param t DOCUMENT ME!
     * @param v DOCUMENT ME!
     * @param ts DOCUMENT ME!
     */
    public void putTransformationTo(Type t, Variant v, TypeTransformation ts) {
        Map tts = (Map) transformations.get(t);

        if (tts == null) {
            tts = new HashMap();
            transformations.put(t, tts);
        }

        tts.put(v, ts);
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public String toString() {
        return "TransformationsFromType[typ=" + typ + " #"
                + transformations.entrySet().size() + "]";
    }
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
